var AT ={
	_DebugMode : false,

	OPEN_WINDOW_METHOD : "",	//ウインドウの開き方(設定から取得)
	PRESENT_TAB:"presentTab",	//現在のタブで開く
	NEW_TAB:"newTab",			//新しいタブで開く
	NEW_WINDOW:"newWindow",		//新しいウインドウで開く

	GOOGLE_TRANSLATE_URL : "",	//Google翻訳URL(設定から取得)
	//http://translate.google.co.jp/translate?hl=ja&sl=en&tl=ja&u=

	TRANSLATE_TO   : "", //翻訳後文字コード(設定から取得)
	TRANSLATE_FROM : "", //翻訳前文字コード(設定から取得)

	RIGHT_CLICK_MENU :"", //右クリックメニューの有無(設定から取得)

	EXTENSION_ID:"autotranslator@kobayashi.ch",

	gl_branch : "",

/********************************************************
 イベントハンドラから初期処理関係
 ********************************************************/
////イベントハンドラ
	handleEvent : function(aEvent){
		if(this._DebugMode) log("function:AT.handleEvent("+aEvent.type+")");

		switch(aEvent.type){
			case "load":
				this.init();
				return;

			case "unload":
				this.destory();
				return;

			default:
				return;
		}
	},

////初期化処理
	init : function(){
		if(this._DebugMode) log("function:AT:init()");

	//初期読み込み設定を実行
		//addEventListenerよりも先に読み込むこと。DOMContentLoadedイベントが先に実行されてしまうから。
		this.readSetting();

	//ブラウザ全体に対する対応
		window.addEventListener("unload",AT,false);

	//タブブラウザに対する対応
		var appcontent = document.getElementById("appcontent");
		if(appcontent){
			//DOM読み込み監視をつける
			appcontent.addEventListener("DOMContentLoaded",this.onPageLoad,false);
		}
	},

////終了処理
	destory : function(){
		if(this._DebugMode) log("function:AT:destory()");

	//ブラウザ全体に対する対応
		window.removeEventListener("unload",AT,false);

	//タブブラウザに対する対応
		var appcontent = document.getElementById("appcontent");
		if(appcontent){
			//DOM読み込み監視を終了
			appcontent.removeEventListener("DOMContentLoaded",this.onPageLoad,false);
		}
	},

////設定読み込み
	readSetting : function(){
		if(this._DebugMode) log("function:AT:readSetting()");

		//ブランチの取得
		var gl_prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		this.gl_Branch=gl_prefs.getBranch("extensions.autotranslator.");

		//設定の取得
		this.OPEN_WINDOW_METHOD = this.gl_Branch.getCharPref("OpenWindowMethod");
		this.GOOGLE_TRANSLATE_URL = this.gl_Branch.getCharPref("TranslateURL");
		this.TRANSLATE_TO = this.gl_Branch.getCharPref("TransraotrTo");	//翻訳後文字コード
		this.RIGHT_CLICK_MENU = this.gl_Branch.getBoolPref("RightClickMenu");//右クリックメニューの有無

	},

////言語コードの取得
	 getLanguageCode : function(languageTag){
		//翻訳前文字コードの確認
		var branchName = "TranslatorFrom."+languageTag;
		var translate_from_bool;
		try{
			translate_from_bool = this.gl_Branch.getBoolPref(branchName);
			this.TRANSLATE_FROM = languageTag;
		}catch(e){
			//そのままの言語コードでは存在しない場合(ja-JPなど)
			var countryCode = languageTag.match(/^[a-z]{2,2}/);
			try{
				branchName = "TranslatorFrom."+countryCode;
				translate_from_bool = this.gl_Branch.getBoolPref(branchName);
				this.TRANSLATE_FROM = countryCode;
			}catch(ee){
				//ja-JPをjaとしても読み込みできなかった
				return false;
			}
		}

		//取得できた翻訳対象言語が翻訳対象になっていれば(true)翻訳実行
		if(translate_from_bool){
			return true;
		}else{
			this.TRANSLATE_FROM = "";
			return false;
		}

		if(this._DebugMode){
			log("open window method : "+this.OPEN_WINDOW_METHOD);
			log("google translate   : "+this.GOOGLE_TRANSLATE_URL);
			log("translate to       : "+this.TRANSLATE_TO);
			log("translate from     : "+this.TRANSLATE_FROM);
			//alert(decodeURIComponent(escape( gl_Branch.getCharPref("Title") )));
		}
		return ;
	},

////ページ読み込み後
	onPageLoad : function(aEvent){
		if(AT._DebugMode) log("function:AT:onPageLoad("+aEvent.type+")");

		//右クリックメニュー追加
		if(AT.RIGHT_CLICK_MENU){
			AT.addRightClickMenu();
		}

		//国コード・言語コードを取得
		var doc = window.content.document;
		var tag_HTML = doc.getElementsByTagName("HTML").item(0);
		var tag_META = doc.getElementsByTagName("META");

		var languageTag = "";

		//metaタグを先に見る
		for(var i=0;i<tag_META.length;i++){
			if(!tag_META.item(i).hasAttributes("http-equiv")==null){
				if(tag_META.item(i).getAttribute("http-equiv").match(/content-language/i)){
					languageTag = tag_META.item(i).getAttribute("content");
					break;
				}
			}
		}

		//metaタグに言語設定がなかったら、HTMLのlangを見る。なかったら終了。
		if(!languageTag){
			if(tag_HTML.hasAttributes("lang")){
				languageTag = tag_HTML.getAttribute("lang");
			}else{
				return;
			}
		}

		if(languageTag==null) return;

		//設定を読み込みする(該当言語がない場合false)
		if(!AT.getLanguageCode(languageTag))	return;

		//URLの作成
		var url = window.content.document.URL;
			url = encodeURIComponent(url);
		translate_url = AT.GOOGLE_TRANSLATE_URL + "hl=" + AT.TRANSLATE_TO + "&sl=" + AT.TRANSLATE_FROM + "&tl=" + AT.TRANSLATE_TO + "&u=" + url;

		//翻訳実行
		AT.translate(translate_url);

	},

////右クリックメニューを追加
	addRightClickMenu : function(){
		if(AT._DebugMode) log("function:AT:addRightClickMenu()");

		var popup = document.getElementById("contentAreaContextMenu");

		if(!document.getElementById(AT.EXTENSION_ID)){

			//このページを翻訳するメニューをつける
			var openNode = document.createElement("menuitem");
			openNode.setAttribute("id",AT.EXTENSION_ID);
			openNode.setAttribute("oncommand","AT.translate()");
			openNode.setAttribute("label","このページを翻訳する");
			popup.appendChild(openNode);
		}
	},

////
	translate : function(translate_url){
	if(AT._DebugMode) log("function:AT:translate()");

	if(!translate_url){
			//URL作成
			var url = window.content.document.URL;
			url = encodeURIComponent(url);

			translate_url = AT.GOOGLE_TRANSLATE_URL + "hl=" + AT.TRANSLATE_TO + "&sl=" + "auto" + "&tl=" + AT.TRANSLATE_TO + "&u=" + url;
	}

	switch(AT.OPEN_WINDOW_METHOD){
			//同じタブで翻訳結果を開く
			case AT.PRESENT_TAB:
				openUILink(translate_url);
				break;

			//新しいタブを開く
			case AT.NEW_TAB:
				//gBrowser.addTab(translate_url);
				//タブの追加とアクティブ化
				gBrowser.selectedTab = gBrowser.addTab(translate_url);
				break;

			//新しいウインドウで開く
			case AT.NEW_WINDOW:
				var win = window.open(translate_url);
				break;

			default:
				if(AT._DebugMode) log(AT.OPEN_WINDOW_METHOD);
		}
	}
}

//エラーコンソールへメッセージを出力する関数
function log(aText) {
	var console = Components.classes["@mozilla.org/consoleservice;1"]
	.getService(Components.interfaces.nsIConsoleService);
	console.logStringMessage(aText);
}